package eu.atosresearch.health.prescripciones.client;

import java.util.List;

import com.google.gwt.user.client.rpc.RemoteService;
import com.google.gwt.user.client.rpc.RemoteServiceRelativePath;

import eu.atosresearch.health.prescripciones.shared.AlarmaBean;
import eu.atosresearch.health.prescripciones.shared.MedicamentoBean;
import eu.atosresearch.health.prescripciones.shared.PacienteBean;
import eu.atosresearch.health.prescripciones.shared.PautaBean;
import eu.atosresearch.health.prescripciones.shared.TomaBean;

/**
 * The client side stub for the RPC service.
 */
@RemoteServiceRelativePath("backend")
public interface BackendService extends RemoteService {
	
	boolean accesoPermitido(String usuario, String pass) throws IllegalArgumentException;
	
	List<PautaBean> getPautas(String usuario) throws IllegalArgumentException;
	List<TomaBean> getTomas(String usuario) throws IllegalArgumentException;
	
	List<PacienteBean> getPacientes(String usuario) throws IllegalArgumentException;
	PacienteBean datosPaciente(String id) throws IllegalArgumentException;
	
	MedicamentoBean getMedicamento(String idMedicamento) throws IllegalArgumentException;

	List<AlarmaBean> getAlarmas(String usuario) throws IllegalArgumentException;
	boolean deleteAlarma(String alarmaId) throws IllegalArgumentException;
	AlarmaBean almacenarAlarma(AlarmaBean alarma, String queSeHace, String cuandoSeHace);
	List<AlarmaBean> obtenerHistoricoAlarmas();

}
