package eu.atosresearch.health.prescripciones.client.widgets.alarmas;

import com.allen_sauer.gwt.log.client.Log;
import com.google.gwt.user.client.ui.DialogBox;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.event.dom.client.ClickEvent;

import eu.atosresearch.health.prescripciones.client.Controlador;
import eu.atosresearch.health.prescripciones.client.ControladorAlarmas;
import eu.atosresearch.health.prescripciones.shared.AlarmaBean;

public class AccionAsumirDialogWidget extends DialogBox {

	private boolean aceptado = false;
	
	public boolean isAceptado() {
		return aceptado;
	}

	public AccionAsumirDialogWidget(String titulo, String texto, final AlarmaBean alarma) {
		setHTML(titulo);
		
		VerticalPanel verticalPanel = new VerticalPanel();
		setWidget(verticalPanel);
		verticalPanel.setSize("100%", "100%");
		
		Label label = new Label(texto);
		verticalPanel.add(label);
		
		HorizontalPanel horizontalPanel = new HorizontalPanel();
		horizontalPanel.setSpacing(15);
		verticalPanel.add(horizontalPanel);
		
		Button btnAceptar = new Button("Aceptar");
		btnAceptar.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				aceptado = true;
				Log.debug("Se autorizó a eliminar la alarma " + alarma.getId());
				ControladorAlarmas.getInstance().eliminarAlarma(alarma);
				hide();
				//Eliminar la alarma del listado
				//borrarFila();
				Log.debug("Eliminar la fila de la alarma en la interfaz");
				try {
					Controlador.getInstance().getMenuWidget().obtenerWidgetFila(alarma.getId()).removeFromParent();
				} catch (Exception ex) {
					Log.error("Error al eliminar la fila " + ex.getMessage() );
				}
				
				Log.debug("Fila de la alarma eliminada");
			}
		});
		horizontalPanel.add(btnAceptar);
		
		Button btnCancelar = new Button("Cancelar");
		btnCancelar.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				aceptado = false;
				Log.debug("Finalmente no se autorizó a eliminar la alarma " + alarma.getId());
				hide();
			}
		});
		horizontalPanel.add(btnCancelar);
		center();
	}
	
	private void borrarFila() {
		Log.debug("Borrando la fila....");
		//getParent().removeFromParent();
		removeFromParent();
	}

}
