package eu.atosresearch.health.prescripciones.client.widgets.alarmas;

import com.allen_sauer.gwt.log.client.Log;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.HasVerticalAlignment;

import eu.atosresearch.health.prescripciones.client.ControladorAlarmas;
import eu.atosresearch.health.prescripciones.client.widgets.AlertaDialogWidget;
import eu.atosresearch.health.prescripciones.shared.AlarmaBean;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.user.client.ui.HasHorizontalAlignment;

public class AlarmaFilaWidget extends Composite {
	
	private AlarmaBean alarmaDelWidget;

	public AlarmaFilaWidget(final AlarmaBean alarma) {
		
		VerticalPanel verticalPanel = new VerticalPanel();
		verticalPanel.setSpacing(4);
		verticalPanel.setWidth("100%");
		initWidget(verticalPanel);
		
		alarmaDelWidget = alarma;
		
		HorizontalPanel horizontalPanel = new HorizontalPanel();
		horizontalPanel.setWidth("100%");
		if (alarma.getPrioridad().equalsIgnoreCase(AlarmaBean.PRIORIDADALTA))
			horizontalPanel.setStyleName("alarmaFilaPrioridadAlta");
		else if (alarma.getPrioridad().equalsIgnoreCase(AlarmaBean.PRIORIDADMEDIA))
			horizontalPanel.setStyleName("alarmaFilaPrioridadMedia");
		else
			horizontalPanel.setStyleName("alarmaFilaPrioridadBaja");
		
		verticalPanel.add(horizontalPanel);
		
		Image imageAlarm = new Image("images/iconsweets2/1361747145_bell_alarm.png");
		horizontalPanel.add(imageAlarm);
		horizontalPanel.setCellVerticalAlignment(imageAlarm, HasVerticalAlignment.ALIGN_MIDDLE);
		
		Label lblPaciente = new Label("Paciente " + alarma.getPacienteId());
		lblPaciente.setWidth("100px");
		horizontalPanel.add(lblPaciente);
		horizontalPanel.setCellVerticalAlignment(lblPaciente, HasVerticalAlignment.ALIGN_MIDDLE);
		
		Label lblFecha = new Label(alarma.getFecha());
		lblFecha.setWidth("120px");
		horizontalPanel.add(lblFecha);
		horizontalPanel.setCellVerticalAlignment(lblFecha, HasVerticalAlignment.ALIGN_MIDDLE);
		
		Label lblDescripcion = new Label(alarma.getDescripcion());
		lblDescripcion.setWidth("500px");
		horizontalPanel.add(lblDescripcion);
		horizontalPanel.setCellVerticalAlignment(lblDescripcion, HasVerticalAlignment.ALIGN_MIDDLE);
		
		Image imageMasInfo = new Image("images/iconsweets2/1361747207_information.png");
		imageMasInfo.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				AccionInfoDialogWidget info = new AccionInfoDialogWidget(alarma);
				info.center();
				info.show();
			}
		});
		horizontalPanel.add(imageMasInfo);
		horizontalPanel.setCellVerticalAlignment(imageMasInfo, HasVerticalAlignment.ALIGN_MIDDLE);
		
		Image imageAsumir = new Image("images/iconsweets2/1361747217_drawers.png");
		imageAsumir.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				AccionAsumirDialogWidget confirmacion = new AccionAsumirDialogWidget("Asumir alarma", "¿Seguro que quieres asumir la alarma?", alarma);
				confirmacion.center();
				confirmacion.show();
//				if (confirmacion.isAceptado())
//				//if (Window.confirm("¿Seguro que quieres asumir la alarma?"))
//					ControladorAlarmas.getInstance().eliminarAlarma(alarma);
//				else
//					Log.debug("Finalmente no se autorizó a eliminar la alarma " + alarma.getId());
			}
		});
		horizontalPanel.add(imageAsumir);
		horizontalPanel.setCellVerticalAlignment(imageAsumir, HasVerticalAlignment.ALIGN_MIDDLE);
		
		Image imageTfno = new Image("images/iconsweets2/1361747173_phone_telephone_call.png");
		imageTfno.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				Log.debug("Dialogo teléfono");
				AccionTelefonoDialogWidget telefonoDialog = new AccionTelefonoDialogWidget(alarma);
				telefonoDialog.center();
				telefonoDialog.show();
			}
		});
		horizontalPanel.add(imageTfno);
		horizontalPanel.setCellVerticalAlignment(imageTfno, HasVerticalAlignment.ALIGN_MIDDLE);
		
		Image imageMail = new Image("images/iconsweets2/1361747195_email_envelope.png");
		imageMail.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				Log.debug("Dialogo enviar email");
				AccionMailDialogWidget mailDialog = new AccionMailDialogWidget(alarma);
				mailDialog.center();
				mailDialog.show();
			}
		});
		horizontalPanel.add(imageMail);
		horizontalPanel.setCellVerticalAlignment(imageMail, HasVerticalAlignment.ALIGN_MIDDLE);
		
		VerticalPanel verticalPanelPrioridad = new VerticalPanel();
		verticalPanelPrioridad.setHorizontalAlignment(HasHorizontalAlignment.ALIGN_RIGHT);
		horizontalPanel.add(verticalPanelPrioridad);
		horizontalPanel.setCellVerticalAlignment(verticalPanelPrioridad, HasVerticalAlignment.ALIGN_MIDDLE);
		
		Label lblIdalarma = new Label("Id " + alarma.getId());
		lblIdalarma.setWidth("150px");
		verticalPanelPrioridad.add(lblIdalarma);
		
		Label lblPrioridad = new Label("Prioridad " + alarma.getPrioridad());
		verticalPanelPrioridad.add(lblPrioridad);
	}

	public AlarmaBean getAlarmaDelWidget() {
		return alarmaDelWidget;
	}

	
}
