package eu.atosresearch.health.prescripciones.client.widgets.pautas;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.allen_sauer.gwt.log.client.Log;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Label;

import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.Grid;

import eu.atosresearch.health.prescripciones.client.ControladorPautas;
import eu.atosresearch.health.prescripciones.shared.MedicamentoBean;
import eu.atosresearch.health.prescripciones.shared.PautaBean;
import eu.atosresearch.health.prescripciones.shared.TomaBean;

import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.i18n.client.DateTimeFormat;
import com.google.gwt.user.client.ui.HasVerticalAlignment;


public class PautaDeUnPacienteWidget extends Composite {

	private Grid grid;
	private Date fechaObservada = new Date();
	private static final long sevenDaysMseconds = 1000 * 60 * 60 * 24 * 7;
	
	public PautaDeUnPacienteWidget() {
		
		VerticalPanel verticalPanel = new VerticalPanel();
		verticalPanel.setSpacing(4);
		initWidget(verticalPanel);
		
		Label lblTitulo = new Label("Pauta para el paciente " + ControladorPautas.getInstance().getPacienteActual().getId());
		lblTitulo.setStyleName("labelTituloSeccion");
		verticalPanel.add(lblTitulo);
		
		Label lblPautaestado = new Label("Estado de la pauta: " + ControladorPautas.getInstance().getPautaActual().getEstado());
		verticalPanel.add(lblPautaestado);
		Label lblPautacreada = new Label("Pauta - inicio: " + ControladorPautas.getInstance().getPautaActual().getFechaInicio() + " " + ControladorPautas.getInstance().getPautaActual().getHoraInicio());
		verticalPanel.add(lblPautacreada);
		TomaBean ultimaToma = ControladorPautas.getInstance().getPautaActual().obtenerTomas().get(ControladorPautas.getInstance().getPautaActual().obtenerTomas().size()-1);
		Label lblPautafin = new Label("Pauta - final: " + ultimaToma.getHora());
		verticalPanel.add(lblPautafin);
		
		HorizontalPanel horizontalPanel = new HorizontalPanel();
		horizontalPanel.setSpacing(12);
		verticalPanel.add(horizontalPanel);
		
		Image imageAtras = new Image("images/iconsweets2/1361769754_up.png");
		imageAtras.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				Log.debug("Calendario atrás");
				fechaObservada = new Date(fechaObservada.getTime() - sevenDaysMseconds);
				Log.debug("Nueva fecha de referencia: " + fechaObservada);
				actualizarSemana(fechaObservada);
			}
		});
		horizontalPanel.add(imageAtras);
		horizontalPanel.setCellVerticalAlignment(imageAtras, HasVerticalAlignment.ALIGN_MIDDLE);
		
		grid = new Grid(5, 7);
		grid.setCellPadding(4);
		grid.setStyleName("gridPautaIndividual");
		actualizarSemana(new Date());
		horizontalPanel.add(grid);
		
		Image imageAdelante = new Image("images/iconsweets2/1361769763_down.png");
		imageAdelante.setStyleName("gridPautaColumnaHoy");
		imageAdelante.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				Log.debug("Calendario adelante");
				fechaObservada = new Date(fechaObservada.getTime() + sevenDaysMseconds);
				Log.debug("Nueva fecha de referencia: " + fechaObservada);
				actualizarSemana(fechaObservada);
			}
		});
		horizontalPanel.add(imageAdelante);
		horizontalPanel.setCellVerticalAlignment(imageAdelante, HasVerticalAlignment.ALIGN_MIDDLE);
		
		//Si no tiene pauta, alarm
		
	}
	
	
	private void actualizarSemana(Date fechaRef) {
		Log.debug("Actualizar grid de la pauta");
		Label dia1 = new Label("lunes");
		Label dia2 = new Label("martes");
		Label dia3 = new Label("miércoles");
		Label dia4 = new Label("jueves");
		Label dia5 = new Label("viernes");
		Label dia6 = new Label("sábado");
		Label dia7 = new Label("domingo");
		dia1.setWidth("130px");
		dia2.setWidth("130px");
		dia3.setWidth("130px");
		dia4.setWidth("130px");
		dia5.setWidth("130px");
		dia6.setWidth("130px");
		dia7.setWidth("130px");
		
		grid.setWidget(0, 0, dia1);
		grid.setWidget(0, 1, dia2);
		grid.setWidget(0, 2, dia3);
		grid.setWidget(0, 3, dia4);
		grid.setWidget(0, 4, dia5);
		grid.setWidget(0, 5, dia6);
		grid.setWidget(0, 6, dia7);
		
//		grid.setText(0, 0, "Lunes");
//		grid.setText(0, 1, "Martes");
//		grid.setText(0, 2, "Miercoles");
//		grid.setText(0, 3, "Jueves");
//		grid.setText(0, 4, "Viernes");
//		grid.setText(0, 5, "Sábado");
//		grid.setText(0, 6, "Domingo");
		
//		grid.getColumnFormatter().setWidth(0, "210px");
//		grid.getColumnFormatter().setWidth(1, "210px");
//		grid.getColumnFormatter().setWidth(2, "210px");
//		grid.getColumnFormatter().setWidth(3, "210px");
//		grid.getColumnFormatter().setWidth(4, "210px");
//		grid.getColumnFormatter().setWidth(5, "210px");
//		grid.getColumnFormatter().setWidth(6, "210px");
		
		for (int col = 0; col < 7; col++)
			grid.getCellFormatter().setStyleName(1, col, "gridPautaBordeAbajo");
		for (int fila = 2; fila <=3; fila ++) 
			for (int col = 0; col < 7; col++) {
				grid.getCellFormatter().setStyleName(fila, col, "gridPautaFondo2");
			}
		
		
		
		grid.setWidth("900px");

		int diaQueEsHoy = fechaRef.getDay();
		if (diaQueEsHoy == 0)
			diaQueEsHoy = 7;
		diaQueEsHoy--;	//Lunes 0, Martes 1....
		
		//Poner un contador a lunes
		Date deLunesADomingo = new Date(fechaRef.getTime() - (1000 * 60 * 60 * 24 * diaQueEsHoy));
		Log.debug("Descubierto el lunes: " + deLunesADomingo);
				
		for (int i=0; i<7; i++) {
			Log.debug("Celda del " + deLunesADomingo);
			Log.debug("Compara " + (new Date()).getTime() + " con " + deLunesADomingo.getTime());
			if (((new Date()).getTime() - deLunesADomingo.getTime() < (1000 * 60 * 60 * 24))
					&& ((new Date()).getTime() - deLunesADomingo.getTime() > (-1000 * 60 * 60 * 24))
					&& ((new Date()).getDay() == deLunesADomingo.getDay())) {
				//Aplicar estilo Hoy
//				Log.debug("Hoy: " + (new Date()) + " que es " + (new Date()).getDay());
//				Log.debug("Comparado con: " + (deLunesADomingo) + " que es " + deLunesADomingo.getDay());
//				Log.debug("Cumple1: " + (new Date()).getTime() + "-" + deLunesADomingo.getTime() + "<" + (1000 * 60 * 60 * 24));
//				Log.debug("Cumple2: " + (new Date()).getTime() + "-" + deLunesADomingo.getTime() + ">" + (-1000 * 60 * 60 * 24));
				grid.getCellFormatter().setStyleName(0, i, "gridPautaColumnaHoy");
				grid.getCellFormatter().setStyleName(1, i, "gridPautaColumnaHoy");
				grid.getColumnFormatter().setStyleName(i, "gridPautaColumnaHoy");
			} else {
				grid.getCellFormatter().removeStyleName(0, i, "gridPautaColumnaHoy");
				grid.getCellFormatter().removeStyleName(1, i, "gridPautaColumnaHoy");
			}
			
			grid.setText(1, i, " " + deLunesADomingo.getDate() + " de " + conversorMeses(deLunesADomingo.getMonth()));
			
			VerticalPanel tomasPrescritas = new VerticalPanel();
			VerticalPanel tomasSistema = new VerticalPanel();
			
			tomasPrescritas.add(new Label("Tomas Pautadas:"));
			tomasSistema.add(new Label("Tomas Realizadas:"));
			try {
				for (TomaBean tb : tomas(ControladorPautas.getInstance().getPautaActual(), deLunesADomingo)) {
					tomasPrescritas.add(new Label(tb.getId() + " - " + tb.getHora().substring(tb.getHora().length()-6) + "..."));
					for (MedicamentoBean mb : tb.getMedicamentosBean().getMedicamentoBean()) {
						//Label medicamentoPautado = new Label(" - " + mb.getId() + " " + mb.getDosis() + ". Ubicación: " + mb.getUbicacion());
						HTML medicamentoPautado = new HTML(" - " + mb.getPpoActivo() + " " + mb.getDosis() + "<br/>Ubicación: " + mb.getUbicacion());
						tomasPrescritas.add(medicamentoPautado);
					}
					boolean seRealizoLaToma = false;
					for (TomaBean tbRealizada : ControladorPautas.getInstance().getTomasCargadas()) {
						if (tbRealizada.getId().equalsIgnoreCase(tb.getId())) {
							//Label tomaRealizada = new Label(" - " + tbRealizada.getId() + ", " + "TOMA REALIZADA " + tbRealizada.getHora());
							HTML tomaRealizada = new HTML(" - " + tbRealizada.getId() + "<br/>" + "REALIZADA" + " " + tbRealizada.getHora().substring(tbRealizada.getHora().length()-6));
							tomaRealizada.setStyleName("labelTomaSatisfecha");
							tomasSistema.add(tomaRealizada);
							seRealizoLaToma = true;
						}
					}
					if (!seRealizoLaToma) {
						if (deLunesADomingo.after(new Date())) {
							HTML tomaRealizada = new HTML(" - " + tb.getId() + "<br/>" + "PENDIENTE");
							//tomaRealizada.setStyleName("labelTomaNoSatisfecha");
							tomasSistema.add(tomaRealizada);
						} else {
							//Label tomaRealizada = new Label(" - " + tb.getId() + ", " + "TOMA NO REALIZADA");
							HTML tomaRealizada = new HTML(" - " + tb.getId() + "<br/>" + "NO REALIZADA");
							tomaRealizada.setStyleName("labelTomaNoSatisfecha");
							tomasSistema.add(tomaRealizada);
						}
					}
				}
			} catch (NullPointerException npex) {
				Log.error("Excepción controlada - no hay pautas cargadas: " + npex.getLocalizedMessage());
				tomasPrescritas.add(new Label("0"));
				tomasSistema.add(new Label("0"));
			}
			grid.setWidget(2, i, tomasPrescritas);
			grid.setWidget(3, i, tomasSistema);
			
			//Día siguiente
			deLunesADomingo = new Date(deLunesADomingo.getTime() + (1000 * 60 * 60 * 24));
		}

		
		
	}
	
	
	private List<TomaBean> tomas(PautaBean pauta, Date fecha) {
		List<TomaBean> tomas = new ArrayList<TomaBean>();
		
		DateTimeFormat dtf = DateTimeFormat.getFormat(("dd-MM-yyyy HH:mm"));
		String fechaAEncontrar = dtf.format(fecha);
		Log.debug("Fecha formateada donde buscar pauta: " + fechaAEncontrar);
		//String fechaAEncontrar = "" + fecha.getDate() +"-"+ (fecha.getMonth()+1) +"-"+ (fecha.getYear()+1900);
		for (TomaBean toma : pauta.obtenerTomas()) {
			//Log.debug("Comparando fechas: " + fechaAEncontrar + " con " + toma.getHora());
			if (toma.getHora().startsWith(fechaAEncontrar.substring(0, 10))) {
				Log.debug("Hay tomas en esta fecha: " + fecha);
				tomas.add(toma);
			}
		}
		return tomas;
	}
	
	private String conversorMeses(int mes) {
		if (mes == 0)
			return "Enero";
		else if (mes == 1)
			return "Febrero";
		else if (mes == 2)
			return "Marzo";
		else if (mes == 3)
			return "Abril";
		else if (mes == 4)
			return "Mayo";
		else if (mes == 5)
			return "Junio";
		else if (mes == 6)
			return "Julio";
		else if (mes == 7)
			return "Agosto";
		else if (mes == 8)
			return "Septiembre";
		else if (mes == 9)
			return "Octubre";
		else if (mes == 10)
			return "Noviembre";
		else if (mes == 11)
			return "Diciembre";
		else 
			return "Mes";
	}

}
