package eu.atosresearch.health.prescripciones.client.widgets.pautas;

import java.util.List;

import com.allen_sauer.gwt.log.client.Log;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.ui.DialogBox;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.ListBox;
import com.google.gwt.user.client.ui.HasHorizontalAlignment;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.core.client.GWT;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.event.dom.client.ClickEvent;

import eu.atosresearch.health.prescripciones.client.BackendService;
import eu.atosresearch.health.prescripciones.client.BackendServiceAsync;
import eu.atosresearch.health.prescripciones.client.Controlador;
import eu.atosresearch.health.prescripciones.client.ControladorPautas;
import eu.atosresearch.health.prescripciones.shared.PacienteBean;

public class SeleccionPacienteDialogWidget extends DialogBox {
	
	private final BackendServiceAsync backendService = GWT.create(BackendService.class);
	
	private ListBox comboBox;
		
	VerticalPanel verticalPanel;
	
	public SeleccionPacienteDialogWidget() {
		setText("Selección de paciente");
				
		verticalPanel = new VerticalPanel();
		setWidget(verticalPanel);
		verticalPanel.setSize("321px", "235px");
		
		Label lblEligeUnoDe = new Label("Elige uno de los pacientes para cargar sus pautas:");
		verticalPanel.add(lblEligeUnoDe);
		
		VerticalPanel verticalPanelCombo = new VerticalPanel();
		verticalPanelCombo.setSpacing(30);
		verticalPanel.setCellHorizontalAlignment(verticalPanelCombo, HasHorizontalAlignment.ALIGN_CENTER);
		verticalPanel.add(verticalPanelCombo);
		
		comboBox = new ListBox();
		backendService.getPacientes(Controlador.getInstance().getUsuarioSistema(), new AsyncCallback<List<PacienteBean>>() {
			public void onFailure(Throwable caught) {
				// Show the RPC error message to the user
				Log.error("Error al solicitar los pacientes." + caught);
			}
			public void onSuccess(List<PacienteBean> pacientesBean) {
				Log.info("Pacientes recibidas");
				Controlador.getInstance().setPacientes(pacientesBean);
				
				for (PacienteBean pb : pacientesBean) {
					comboBox.addItem(pb.getId());
				}
			}
		});		
		verticalPanel.setCellHorizontalAlignment(comboBox, HasHorizontalAlignment.ALIGN_CENTER);
		
		verticalPanelCombo.add(comboBox);
		
		
		Button btnAceptar = new Button("Aceptar");
		btnAceptar.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				for (PacienteBean pb : Controlador.getInstance().getPacientes()) {
					if (pb.getId().equalsIgnoreCase(comboBox.getValue(comboBox.getSelectedIndex()))) {
						ControladorPautas.getInstance().setPacienteActual(pb);
						Log.info("Paciente para el sistema: " + pb.getId());
						//hide();
						ControladorPautas.getInstance().pacienteSeleccionado();
						pacienteElegido();
					}
				}
			}
		});
		verticalPanel.add(btnAceptar);
		verticalPanel.setCellHorizontalAlignment(btnAceptar, HasHorizontalAlignment.ALIGN_CENTER);

	}
	
	
	//Pantalla con la pauta
	private void pacienteElegido() {
		verticalPanel.clear();
		setText("Paciente " + ControladorPautas.getInstance().getPacienteActual().getId());
		
		//Meter el widget de la pauta
		PautaDeUnPacienteWidget pautaWidget = new PautaDeUnPacienteWidget();
		verticalPanel.add(pautaWidget);
		
		center();
		
		Log.debug("Pie del diálogo - aceptar");
		Button btnAceptar = new Button("Aceptar");
		btnAceptar.addClickHandler(new ClickHandler() {
			public void onClick(ClickEvent event) {
				Log.debug("Salir de la visualización de la pauta");
				hide();
			}
		});
		verticalPanel.add(btnAceptar);
		verticalPanel.setCellHorizontalAlignment(btnAceptar, HasHorizontalAlignment.ALIGN_CENTER);
	}

}
