package eu.atosresearch.health.prescripciones.shared;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

public class PautaBean implements Serializable {

	private static final long serialVersionUID = 1L;

	public static final String ESTADOLATENTE  = "Latente";
	public static final String ESTADOACTIVA   = "Activa";
	public static final String ESTADOINACTIVA = "Inactiva";
	
	public PautaBean() {
	}
	
	
	
	protected String nombreFichero;
    protected String fechaInicio;
    protected String horaInicio;
    protected DiasBean diasBean;
    protected String id;
    protected String pacienteId;
    protected String estado;

    public String getNombreFichero() {
        return nombreFichero;
    }

    public void setNombreFichero(String value) {
        this.nombreFichero = value;
    }
    
    public String getFechaInicio() {
        return fechaInicio;
    }

    public void setFechaInicio(String value) {
        this.fechaInicio = value;
    }

    public String getHoraInicio() {
        return horaInicio;
    }

    public void setHoraInicio(String value) {
        this.horaInicio = value;
    }

    public DiasBean getDiasBean() {
        return diasBean;
    }

    public void setDiasBean(DiasBean value) {
        this.diasBean = value;
    }

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}
    
	public String getPacienteId() {
		return pacienteId;
	}

	public void setPacienteId(String pacienteId) {
		this.pacienteId = pacienteId;
	}

	public String getEstado() {
		return estado;
	}

	public void setEstado(String estado) {
		this.estado = estado;
	}

	//Tomas de una pauta
	public List<TomaBean> obtenerTomas() {
		List<TomaBean> resultadoTomasPresentes = new ArrayList<TomaBean>();
		for (DiaBean db : getDiasBean().getDiaBean()) {
			for (TomaBean tb : db.getTomasBean().getTomaBean()) {
				//for (TomaBean tbargumento : tomas) {
					//if (tbargumento.getId().equalsIgnoreCase(tb.getId())) {
						resultadoTomasPresentes.add(tb);
					//	break;
					//}
				//}
			}
		}
		return resultadoTomasPresentes;
	}
	
	
	//Toma en una pauta
	public TomaBean obtenerToma(String tomaId) {
		for (DiaBean db : getDiasBean().getDiaBean()) {
			for (TomaBean tb : db.getTomasBean().getTomaBean()) {
				if (tb.getId().equalsIgnoreCase(tomaId)) {
					return tb;
				}
			}
		}
		return null;
	}

}
